From fedc9444e9dcb9177c39dbff52edc8595ee46b58 Mon Sep 17 00:00:00 2001
From: Arina Neshlyaeva <arina.neshlyaeva@intel.com>
Date: Tue, 20 Sep 2022 17:08:05 -0700
Subject: [PATCH] Fixed signature of llvm.memcpy intrinsic in opaque mode

---
 src/ctx.cpp | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/src/ctx.cpp b/src/ctx.cpp
index 66e82c048..fa12dcbee 100644
--- a/src/ctx.cpp
+++ b/src/ctx.cpp
@@ -3083,8 +3083,13 @@ void FunctionEmitContext::MemcpyInst(llvm::Value *dest, llvm::Value *src, llvm::
     if (align == NULL)
         align = LLVMInt32(1);
     llvm::FunctionCallee mcFuncCallee =
+#ifdef ISPC_OPAQUE_PTR_MODE
+        m->module->getOrInsertFunction("llvm.memcpy.p0.p0.i64", LLVMTypes::VoidType, LLVMTypes::VoidPointerType,
+                                       LLVMTypes::VoidPointerType, LLVMTypes::Int64Type, LLVMTypes::BoolType);
+#else
         m->module->getOrInsertFunction("llvm.memcpy.p0i8.p0i8.i64", LLVMTypes::VoidType, LLVMTypes::VoidPointerType,
                                        LLVMTypes::VoidPointerType, LLVMTypes::Int64Type, LLVMTypes::BoolType);
+#endif
     llvm::Constant *mcFunc = llvm::cast<llvm::Constant>(mcFuncCallee.getCallee());
     AssertPos(currentPos, mcFunc != NULL);
     AssertPos(currentPos, llvm::isa<llvm::Function>(mcFunc));
